//+------------------------------------------------------------------+
//|																geVerticalExstemum.mq4		|
//|                      Copyright  2007, ver 1.0							|
//|                      Forte928           									|
//+------------------------------------------------------------------+
#property copyright "Forte928"
#property link      ""
#define		IndicatorName "geVerticalExstemum"

#property indicator_chart_window

#property indicator_buffers 2
#property indicator_color1 PaleGreen//Goldenrod//LightSkyBlue
#property indicator_color2 OrangeRed

//----
extern int		Depth			= 20;
extern int		WidthLine	= 1;
extern int		NumberOfDays= 2;
extern string	_info_		= "Type 0-Line, 1-Arrow";
extern int		Type			= 0; 

int	Shift;
bool	InitDraw;
datetime TimeSave;
int	VerticalLine;
int	PauseDraw;
color	ayColor[7]={Red,Orange,Yellow,Lime,Aqua,Blue,Violet};
int	IxColor;
//+------------------------------------------------------------------+
//| Custom indicator initialization function |
//+------------------------------------------------------------------+
int init()
{
	TimeSave=0;
	InitDraw=false;
	VerticalLine=0;
	IxColor=0;
	ObjectsDeleteAll();
	return(0);
}
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function |
//+------------------------------------------------------------------+
int deinit()
{
//---- 
	ObjectsDeleteAll();
//----
return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function |
//+------------------------------------------------------------------+
int start()
{
//           
//	if ((Time[0]==TimeSave)&&(InitDraw==true)) return;
	
PauseDraw=1;
int		iCount;
if (InitDraw==false) iCount=Bars-1;
else iCount=iBarShift(NULL,0,TimeSave,false);

	int		IxMax=iCount-1;
	int		IxMin=iCount-1;	
	int		IxPoint=iCount-1;

	if (InitDraw==true) {
	//	Print("VerticalLine >",DoubleToStr(VerticalLine,0));
	//	return;
		if (ObjectFind("Min"+DoubleToStr(VerticalLine,0))>=0){
			//Print("Delete Line=",VerticalLine);
			ObjectDelete("Min"+DoubleToStr(VerticalLine,0));
		}
		if (ObjectFind("Max"+DoubleToStr(VerticalLine,0))>=0) {
			//Print("Delete Line=",VerticalLine);
			ObjectDelete("Max"+DoubleToStr(VerticalLine,0));
		}
		VerticalLine=VerticalLine-1;
	}
	while  (IxPoint>=0) {
		if (High[IxPoint]>High[IxMax]) IxMax=IxPoint;
		if (Low[IxPoint]<Low[IxMin]) IxMin=IxPoint;
		if ((IxMax>IxMin)&&(IxMin>IxPoint)) {
			if (((High[IxPoint]-Low[IxMin])/Point)>Depth){
				DrawVertical("Max",3,IxMax);
				TimeSave=Time[IxMax+1];
				IxMax=IxPoint;
			}
		}
		if ((IxMax<IxMin)&&(IxMax>IxPoint)) {
			if (((High[IxMax]-Low[IxPoint])/Point)>Depth){
				DrawVertical("Min",1,IxMin);
				TimeSave=Time[IxMin+1];
				IxMin=IxPoint;
			}
		}
		IxPoint=IxPoint-1;
	}
	if (InitDraw==false) {
		InitDraw=true;
		if (IxMax>IxMin) { 
			DrawVertical("Max",3,IxMax);
			DrawVertical("Min",1,IxMin);
		}
		else {
			DrawVertical("Min",1,IxMin);
			DrawVertical("Max",3,IxMax);
		}
	}
	else {
	//Print("Color >",IxColor);
		if (IxColor==0) IxColor=ArraySize(ayColor)+1;
		IxColor=IxColor-1;
		if (IxMax<IxMin)	DrawVertical("Max",3,IxMax);
		else DrawVertical("Min",1,IxMin);
	}
	return(0);
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void DrawVertical(string iPrefix,int iWidth,int iTimeShift)
{
	PauseDraw=PauseDraw-1;
	if (PauseDraw>=0) return;
	VerticalLine=VerticalLine+1;
	string PrefixLine=iPrefix+DoubleToStr(VerticalLine,0);
	string InfoLine=TimeToStr(Time[iTimeShift],TIME_MINUTES);
	if (Type==0) {
		ObjectCreate(PrefixLine, OBJ_VLINE, 0, Time[iTimeShift], 0);
		ObjectSet(PrefixLine, OBJPROP_WIDTH,iWidth);
	}
	else {
		if (iWidth>1) {
			ObjectCreate(PrefixLine, OBJ_ARROW, 0, Time[iTimeShift], High[iTimeShift]+10*Point);
			ObjectSet(PrefixLine, OBJPROP_ARROWCODE,242); 
		}
		else {
			ObjectCreate(PrefixLine, OBJ_ARROW, 0, Time[iTimeShift], Low[iTimeShift]-10*Point);
			ObjectSet(PrefixLine, OBJPROP_ARROWCODE,241); 
		}
	}
	ObjectSetText(PrefixLine, InfoLine);
	ObjectSet(PrefixLine, OBJPROP_STYLE,0); 
	ObjectSet(PrefixLine, OBJPROP_COLOR,ayColor[IxColor]);
	IxColor=MathMod(IxColor+1,ArraySize(ayColor));
	return;
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

